//l'utilisation d'un shield ethernet pose des problèmes de cablages
//il faut donc HACKER les fichiers arduino de ressources et suivre la
//marche à suivre postée ici par tofe86: http://arduino.cc/forum/index.php/topic,22111.0.html
//fonctionne avec arduino 22, duemillanove et UNO
//fournis avec ce fichier le hack à copier coller directement dans votre dossier arduino
//attention, si vous voulez travailler normalement avec le shield ethernet,
//installez un deuxième arduino 22 intact ailleurs
//CABLAGE:
/*
BLANK   -> PB2 (D10)
XLAT     -> PB1 (D9)
SIN       -> PD7 (D7)
XERR     -> PD6 (D6)
SCLK     -> PD4 (D4)
GSCLK   -> PD3 (D3)

Ponter dans l'ethernet shield:

D10 -> D8

*/
#include <SPI.h>         // needed for Arduino versions later than 0018
#include <Ethernet.h>
#include <Udp.h>         // UDP library from: bjoern@cs.stanford.edu 12/30/2008

#include "Tlc5940.h"

#define short_get_high_byte(x) ((HIGH_BYTE & x) >> 8)
#define short_get_low_byte(x)  (LOW_BYTE & x)
#define bytes_to_short(h,l) ( ((h << 8) & 0xff00) | (l & 0x00FF) );


// ADRESSES MAC ET IP du shield ethernet
//l'adresse MAC de la carte réseau est collée dans un sticker au dos de la carte
//pour la traduire en décimale, utiliser: http://www.frankdevelopper.com/outils/convertisseur.php

byte mac[] = {  144, 162, 218, 00, 16, 96  };
byte ip[] = {   192,168,1,177 };
// the next two variables are set when a packet is received
byte remoteIp[4];        // holds received packet's originating IP
unsigned int remotePort; // holds received packet's originating port
//Paramètres art net
unsigned int localPort = 6454;      // port UDP générique art-net=6454
const int nombre_de_circuits=512;
const int taille_chaine_artnet=8+17+nombre_de_circuits+1;

// buffers
const int MAX_BUFFER_UDP=1024;
char packetBuffer[MAX_BUFFER_UDP]; //buffer de stockage de la trame entrante
byte buffer_dmx[nombre_de_circuits]; //buffer de stockage du dmx

//Variables d'identification Art-Net
char ArtNetHead[8]="Art-Net";
char OpHbyteReceive=0;
char OpLbyteReceive=0;
short is_artnet_version_1=0;
short is_artnet_version_2=0;
short seq_artnet=0;
short artnet_physical=0;
short incoming_universe=0;
boolean is_opcode_is_dmx=0;
boolean is_opcode_is_artpoll=0;
boolean match_artnet=1;
short Opcode=0;


void setup()
{
  /* Call Tlc.init() to setup the tlc.
     You can optionally pass an initial PWM value (0 - 4095) for all channels.*/
  Tlc.init();
  Ethernet.begin(mac,ip);
  Udp.begin(localPort);
}


void loop()
{
  
   
  int packetSize = Udp.available();
  if(packetSize==taille_chaine_artnet)//si un packet de la taille de la chaine art-net
  {
    Udp.readPacket(packetBuffer,MAX_BUFFER_UDP, remoteIp, remotePort);  
    //lecture de l'identifiant
     match_artnet=1;//valeur de stockage
     for (int i=0;i<7;i++)
     {
      if(char(packetBuffer[i])!=ArtNetHead[i])
      {match_artnet=0;break;}//si ce n'est pas correspondant au header Art-Net, on arrête
     } 
     if (match_artnet==1)
     { 
      //version protocole utilisé
      //is_artnet_version_1=packetBuffer[10]; 
      //is_artnet_version_2=packetBuffer[11];
      //séquence d'envoi des données
      //seq_artnet=packetBuffer[12];//0
      //émission de la trame venant du port physique dmx N°
      //artnet_physical=packetBuffer[13];//
      
     //operator code qui permet de savoir de quel type de message Art-Net il s'agit
     Opcode=bytes_to_short(packetBuffer[9],packetBuffer[8]);
     if(Opcode==0x5000)//il s'agit d'une trame dmx
      {
       is_opcode_is_dmx=1;is_opcode_is_artpoll=0;
       }   
     else if(Opcode==0x2000)//il s'agit d'un artpoll: un node art-net demande sur le réseau qui est présent
     {
     is_opcode_is_artpoll=1;is_opcode_is_dmx=0;
     //ici il faudrait renvoyer une trame artpoll reply au node qui a lancé le art-poll
     } 
 
     if(  is_opcode_is_dmx=1)
     {
     //Extraction de l'univers DMX, si vous avez besoin de filtre
     //incoming_universe= bytes_to_short(packetBuffer[15],packetBuffer[14]);//extraction de l'univers
     
     //report dans un buffer dmx de la trame reçue
     for(int i=0;i<nombre_de_circuits;i++)
      {
     buffer_dmx[i]= byte(packetBuffer[i+17]);
       }
     for (int channel = 0; channel < NUM_TLCS * 16; channel ++) 
  {    
    Tlc.set(channel,(int) (buffer_dmx[channel]*16) );
    Tlc.update();
  }
   
      }
 
     }//fin de l'analyse 
    
  }



}

